const Gtk = imports.gi.Gtk;
const GObject = imports.gi.GObject;
const Gio = imports.gi.Gio;
const Lang = imports.lang;

const ExtensionUtils = imports.misc.extensionUtils;
const Me = ExtensionUtils.getCurrentExtension();
const Convenience = Me.imports.convenience;

const LOCKDOWN_SCHEMA = 'org.gnome.shell';
const ALWAYS_SHOW_LOG_OUT_KEY = 'always-show-log-out';

function SettingsWidget() {
    this._init();
}

SettingsWidget.prototype = {
    
    _init: function() {
      this.settings = Convenience.getSettings(LOCKDOWN_SCHEMA);
    },

    changeShowLogOutBttn: function(object, pspec) {
     this.settings.set_boolean(ALWAYS_SHOW_LOG_OUT_KEY, object.get_active());
    },
    
    buildPrefsWidget: function() {
      let widget = new Gtk.Box({ orientation: Gtk.Orientation.VERTICAL, border_width: 10 });
      
      let vbox = new Gtk.Box({ orientation: Gtk.Orientation.VERTICAL, margin_left: 20 });
      
      let hboxReplace = new Gtk.Box({orientation: Gtk.Orientation.HORIZONTAL});
      let labelReplace = new Gtk.Label({label: "Show Log Out Button", xalign: 0});
      let valueReplace = new Gtk.Switch({active: this.settings.get_boolean(ALWAYS_SHOW_LOG_OUT_KEY)});
      valueReplace.connect('notify::active', Lang.bind(this, this.changeShowLogOutBttn));
      
      hboxReplace.pack_start(labelReplace, true, true, 0);
      hboxReplace.add(valueReplace);
      vbox.add(hboxReplace);
 
      widget.add(vbox);
      
      widget.show_all();
      
      return widget;
    }
};

function init() {
}

function buildPrefsWidget() {
  let widget = new SettingsWidget();
  return widget.buildPrefsWidget();
}
